

//	This source and compression method apply to GNU General Public License. 
//			Copyright (C) 2009 Jasenko Dzinleski 





//		This program is free software; you can redistribute it
//	and/or modify it under the terms of the GNU General Public License as
//	published by the Free Software Foundation; either version 2 of the
//	License, or (at your option) any later version. 

//	This program is distributed in the hope that it will be useful, but
//	WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
//	General Public License for more details. 


//	You should have received a copy of the GNU General Public License along
//	with this program; if not, write to the Free Software Foundation, Inc.,
//	51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.



//
//			Bit Parity Byte Order Cheksum
//
//			written by Dzinleski Jasenko March,2009
//
//			to Maria Dzinleska




#include <stdio.h>
#include <string.h>

#define	fbl	1024

char 		in1fn[255]="book_sd.txt";
char 		out1fn[255]="c.mar";
char 		cs1fn[255]="bo_cs_output.txt";

FILE		*f1,*f2,*f3;

long		b8o,b8e;
long		b16o,b16e;

int		ba[fbl][3];		int	bai=0;

int		bc[fbl/2][2];		int	bci=0;
int		br[fbl/2];		


int bp_boc(char infn[256],char csfn[256])
{

	int		i,j,k,l,m,n;
	int		i0,i1,j1;
	int		a1,b1,c1;
	int		a2,b2,c2,c21,c22,c23;
	int		c31,c32,c33;
	int		a3,b3,c3;
	int		c4;
	int		a,b,c,d;
	int		lc1,lc2,lc3;
	int		bcc=0;

	b8o=0;
	b8o|=1<<0;
	b8o|=1<<2;
	b8o|=1<<4;
	b8o|=1<<6;

	b8e=0;
	b8e|=1<<1;
	b8e|=1<<3;
	b8e|=1<<5;
	b8e|=1<<7;

	b16o=0;
	b16o|=1<<0;
	b16o|=1<<2;
	b16o|=1<<4;
	b16o|=1<<6;
	b16o|=1<<8;
	b16o|=1<<10;
	b16o|=1<<12;
	b16o|=1<<14;
	
	b16e=0;
	b16e|=1<<1;
	b16e|=1<<3;
	b16e|=1<<5;
	b16e|=1<<7;
	b16e|=1<<9;
	b16e|=1<<11;
	b16e|=1<<13;
	b16e|=1<<15;

	br[0]=-1;

	f1=fopen(infn,"rb");
	f2=fopen(out1fn,"wb");

	i=getc(f1);i1=i;i0=i;fprintf(f2,"%c",i0);
	j=getc(f1);
	while(!feof(f1))
	{


		a1=((((b8e&i)>>1)^((b8e&j)>>1))<<1)|((b8o&i)^(b8o&j));ba[bai][0]=a1;

		i=j;j=getc(f1);j1=j;
		b1=((((b8e&i)>>1)^((b8e&j)>>1))<<1)|((b8o&i)^(b8o&j));ba[bai][1]=b1;

		ba[bai][2]=(a1<<8)|b1;++bai;++bcc;


		if(bcc==2||bai==fbl)
		{

			c1=((((b8e&ba[-2+bai][0])>>1)^((b8e&ba[-2+bai][1])>>1))<<1)|((b8o&ba[-2+bai][0])^(b8o&ba[-2+bai][1]));

			m=0;lc1=0;
			for(i=0;i<256;++i)
			{
				a2=((((b8e&i1)>>1)^((b8e&i)>>1))<<1)|((b8o&i1)^(b8o&i));
				for(j=0;j<256;++j)
				{
					

					b2=((((b8e&i)>>1)^((b8e&j)>>1))<<1)|((b8o&i)^(b8o&j));
				
					c21=((((b8e&a2)>>1)^((b8e&b2)>>1))<<1)|((b8o&a2)^(b8o&b2));

					if(c1==c21){
					if(a2==ba[-2+bai][0]&&b2==ba[-2+bai][1]){++m;/*printf(".%d.",lc1);*/break;}else{++lc1;}}

				}if(m!=0){break;}

			}if(m==0){printf("Error...1\n");return(0);}

			c2=((((b8e&ba[-1+bai][0])>>1)^((b8e&ba[-1+bai][1])>>1))<<1)|((b8o&ba[-1+bai][0])^(b8o&ba[-1+bai][1]));

			m=0;lc2=0;
			for(k=0;k<256;++k)
			{
				a3=((((b8e&j)>>1)^((b8e&k)>>1))<<1)|((b8o&j)^(b8o&k));
				for(l=0;l<256;++l)
				{
					

					b3=((((b8e&k)>>1)^((b8e&l)>>1))<<1)|((b8o&k)^(b8o&l));

					c22=((((b8e&a3)>>1)^((b8e&b3)>>1))<<1)|((b8o&a3)^(b8o&b3));

					if(c2==c22){
					if(a3==ba[-1+bai][0]&&b3==ba[-1+bai][1]){++m;/*printf(".%d.",lc2);*/break;}else{++lc2;}}

				}if(m!=0){break;}

			}if(m==0){printf("Error...2\n");return(0);}
							
			//if(c1==c21&&c2==c22){printf(".%d %d.",lc1,lc2);}
			
			c3=((((b8e&c1)>>1)^((b8e&c2)>>1))<<1)|((b8o&c1)^(b8o&c2));					

			m=0;lc3=0;
			for(i=0;i<256;++i)
			{
				for(j=0;j<256;++j)
				{

					c31=((((b8e&i)>>1)^((b8e&j)>>1))<<1)|((b8o&i)^(b8o&j));					

					if(c3==c31){
					if(c1==i&&c2==j){++m;/*printf(".%d.",lc3);*/break;}else{++lc3;}}

				}if(m!=0){break;}

			}if(m==0){printf("Error...3\n");return(0);}
				
			//printf("%d-%d ",c3,((lc1*lc2*lc3)%0x00ff));
			fprintf(f2,"%c%c",c3,((lc1*lc2*lc3)%0x00ff));

			bc[bci][0]=c3;bc[bci][1]=((lc1*lc2*lc3)%0x00ff);++bci;
			if(bci==fbl/2){
				if(br[0]==-1){
					for(i=0;i<fbl/2;++i){br[i]=(bc[i][0]*bc[i][1]);}}else{
						for(i=0;i<fbl/2;++i){br[i]^=(bc[i][0]*bc[i][1]);}}
				bci=0;
			}

			bcc=0;i1=j1;if(bai==fbl){bai=0;fprintf(f2,"%c",i0);i0=j1;}
			
		}

		i=j1;
		j=getc(f1);

	}
	fclose(f1);
	fclose(f2);

	f3=fopen(csfn,"wb");j=0;for(i=0;i<fbl/2;++i){printf("%05d ",br[i]);++j;if(j==15){printf("\n");j=0;}fprintf(f3,"%05d ",br[i]);}fclose(f3);
	printf("\n");

	return(1);

}


int main(int argc,char *argv[])
{


	int	i,j,k,l,m;

	printf("\nBit Parity Byte Order Cheksum\n");
	printf("written by Dzinleski Jasenko March,2009\n");
	printf("\nOS Win32 VRM 1.3.0\n\n");

	if(argv[1]!=NULL)
	{
  		strcpy(in1fn,argv[1]);
		if(in1fn[0]=='-')
		{
			if(in1fn[1]=='l'||in1fn[1]=='e')
			{

				printf("\nBit Parity Byte Order Cheksum\n");
				printf("written by Dzinleski Jasenko March,2009\n");
				printf("\nOS Win32 VRM 1.3.0\n\n");
				printf("\n");
				printf("\tThis source and Bit Parity Byte Order Cheksum method apply to GNU General Public License.\n");
				printf("\t		Copyright (C) 2009 Jasenko Dzinleski \n");
				printf("\n");
				printf("\t	This program is free software; you can redistribute it\n");
				printf("\tand/or modify it under the terms of the GNU General Public License as\n");
				printf("\tpublished by the Free Software Foundation; either version 2 of the\n");
				printf("\tLicense, or (at your option) any later version.\n");
				printf("\n");
				printf("\tThis program is distributed in the hope that it will be useful, but\n");
				printf("\tWITHOUT ANY WARRANTY; without even the implied warranty of\n");
				printf("\tMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU\n");
				printf("\tGeneral Public License for more details.\n");
				printf("\n");
				printf("\tYou should have received a copy of the GNU General Public License along\n");
				printf("\twith this program; if not, write to the Free Software Foundation, Inc.,\n");
				printf("\t51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.\n");
				printf("\n");
				return(0);

			}else{
				if(in1fn[1]=='h')
				{
					printf("\nBit Parity Byte Order Cheksum\n");
					printf("written by Dzinleski Jasenko March,2009\n");
					printf("\nOS Win32 VRM 1.3.0\n\n");
					printf("\n");
					printf("boc <input filename> <cheksum output filename>\n");
					printf("\n");
					return(0);
				}else{
					strcpy(in1fn,argv[1]);
					strcpy(cs1fn,argv[2]);
				}
			}

		}else{
				strcpy(in1fn,argv[1]);
				strcpy(cs1fn,argv[2]);
		}

	}else{return(0);}

	f1=fopen(in1fn,"rb");
	if(f1==NULL)
	{
		printf("No input file...\n");return(0);

	}else{fclose(f1);}

	if(1==bp_boc(in1fn,cs1fn)){printf("\nOk\n");}

	return(0);
}
